# SPDX-FileCopyrightText: ☭ Emery Hemingway
# SPDX-License-Identifier: Unlicense

import std/[asyncdispatch, os, uri]
import preserves, syndicate, syndicate/capabilities
import ./protocol, ./common

proc publishUri(turn: var Turn; ds: Ref) =
  for arg in commandLineParams():
    if fileExists(arg):
      message(turn, ds, Open(uri: protocol.Uri(
          scheme: "file", path: arg.absolutePath.toPreserve)))
    else:
      message(turn, ds, initRecord("open", arg.parseUri.toPreserve))
  stop(turn)

proc unixSocketPath: Unix =
  result.path = getEnv("SYNDICATE_SOCK")
  if result.path == "":
    result.path = getEnv("XDG_RUNTIME_DIR", "/run/user/1000") / "dataspace"

discard bootDataspace("open") do (root: Ref; turn: var Turn):
  let cap = mint().toPreserve(Ref)
  connect(turn, unixSocketPath(), cap, publishUri)

for i in 0..4: poll(20)
  # A hack to exit
